if in_astate("davvis", 0) then
	local status, err = pcall(function()
		statecaught = true

		local stat_y = 56

		-- How many "lives" do we have? ;)
		if vis_player.deaths < 3 then
			love.graphics.setColor(255, 0, 255)
			for i = 1, 3-vis_player.deaths do
				drawentity(enemysprites[8], 16+32*(i-1), 16)
			end
			love.graphics.setColor(128,128,128)
		else
			love.graphics.setColor(128,128,128)
			love.graphics.print("Deaths:  " .. vis_player.deaths, 8, 46) -- 46 would be stat_y
		end

		-- Also display stuff like trinkets and crewmates
		if vis_trinkets_total > 0 then
			love.graphics.print("Trinkets:" .. vis_n_trinkets .. "/" .. vis_trinkets_total, 8, stat_y)
			stat_y = stat_y + 10
		end
		if vis_crewmates_total > 0 then
			love.graphics.print("Crew:    " .. vis_n_crewmates .. "/" .. vis_crewmates_total, 8, stat_y)
			stat_y = stat_y + 10
		end
		if vis_player.flippable then
			love.graphics.print("Flippable", 8, stat_y)
		end

		-- Display some things
		love.graphics.print("Audio " .. (love.audio.getVolume() == 0 and "OFF" or "ON"), love.graphics.getWidth()-115, 8)

		-- Presumably there would be a debug setting, but time constraints
		if true then
			-- Display all the flags
			love.graphics.setFont(tinynumbers)
			love.graphics.print("{FLAGS", love.graphics.getWidth()-115, love.graphics.getHeight()-86)
			for tens = 0, 9 do
				for units = 0, 9 do
					if vis_scripting.flags[tonumber(tens*10+units)] then
						love.graphics.setColor(255,255,255)
					else
						love.graphics.setColor(128,128,128)
					end
					--local 
					love.graphics.print(fixdig(tens*10+units, 2), love.graphics.getWidth()-16-((9-tens)*11), (love.graphics.getHeight()-78)+units*7)
				end
			end
			love.graphics.setFont(font8)
		end

		if vis_flashtimer > 0 then
			love.graphics.setColor(0xbb, 0xbb, 0xbb)
			love.graphics.rectangle("fill", screenoffset-0.5, -0.5, 640+1, 480+1)
			return
		end
		love.graphics.setColor(255, 255, 255)
		love.graphics.rectangle("line", screenoffset-0.5, -0.5, 640+1, 480+1)

		love.graphics.setScissor(screenoffset, 0, 640, 480)

		-- Earthquake mode?
		local shakeoffx, shakeoffy = 0, 0
		if vis_shaketimer > 0 then
			shakeoffx, shakeoffy = math.random(-8,8), math.random(-8,8)
		end

		local thismeta = levelmetadata[(roomy)*20 + (roomx+1)]

		-- Background
		if thismeta.warpdir == 1 or thismeta.warpdir == 2 then
			-- Horizontal/vertical warp direction.
			vis_drawbackground("warphv", thismeta)
		elseif thismeta.warpdir == 3 then
			-- Warping in all directions.
			vis_drawbackground("warpa", thismeta)
		elseif thismeta.tileset == 2 then
			-- Lab
			vis_drawbackground("lab", thismeta)
		end

		-- Tiles
		displayroom(screenoffset+shakeoffx, shakeoffy, roomdata[roomy][roomx], thismeta, nil, false)

		--love.graphics.setFont(font8)
		--displayentities(screenoffset, 0, roomx, roomy)

		for k,v in pairs(vis_unsolid_entities) do
			v:draw(shakeoffx, shakeoffy)
		end
		for k,v in pairs(vis_solid_entities) do
			v:draw(shakeoffx, shakeoffy)
		end

		vis_player:draw(shakeoffx, shakeoffy)

		if false and love.mouse.isDown("r") then
			local dbgg_x = (love.mouse.getX()-screenoffset)/2
			local dbgg_y = love.mouse.getY()/2
			if vis_player:isinsidewall(dbgg_x, dbgg_y) then
			--if vis_player:touching(dbgg_x, dbgg_y, vis_player.w, vis_player.h) then
				love.graphics.setColor(255,0,0, 128)
			else
				love.graphics.setColor(0,255,0, 128)
			end
			love.graphics.rectangle("fill", screenoffset+dbgg_x*2, dbgg_y*2, vis_player.w*2, vis_player.h*2)
			love.graphics.setColor(255,255,255)
		end

		-- Room name
		if thismeta.roomname ~= "" then
			local text = thismeta.roomname
			local textx = (screenoffset+320)-(font16:getWidth(text)/2)

			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill", screenoffset, 29*16, 40*16, 16)
			love.graphics.setColor(255,255,255,255)
			love.graphics.setFont(font16)
			love.graphics.setScissor(screenoffset, 29*16, 40*16, 16)
			love.graphics.print(text, textx, 29*16 +3)
			love.graphics.setScissor(screenoffset, 0, 640, 480)
			love.graphics.setFont(font8)
		end

		-- Cutscene bars
		if vis_cutscenebars ~= 0 then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill", screenoffset, 0, vis_cutscenebars*2, 32)
			love.graphics.rectangle("fill", screenoffset+(320-vis_cutscenebars)*2, 480-32, vis_cutscenebars*2, 32)
			love.graphics.setColor(255,255,255)
		end

		-- Press ACTION to advance text
		if vis_scripting.keywait then
			love.graphics.setFont(font16)
			love.graphics.printf("[ Press ACTION to advance text ]", screenoffset, 11, 640, "center")
			love.graphics.setFont(font8)
		end

		for k,v in pairs(vvvvvv_textboxes) do
			vvvvvv_textbox(unpack(v))
		end

		love.graphics.setScissor()
	end, dt)

	if not status then
		vis_crash(err)
	end
elseif in_astate("davvis", 1) then
	statecaught = true

	love.graphics.draw(mapscreenshot, 0, 0, 0, s.pscale^-1)

	if vis_crash_holdingbtn ~= 0 then
		love.graphics.draw(vis_crashmsgs[vis_crash_image .. "b"], vis_crash_x, vis_crash_y)
	else
		love.graphics.draw(vis_crashmsgs[vis_crash_image], vis_crash_x, vis_crash_y)
	end
elseif in_astate("davvis", 2) then
	statecaught = true

	love.graphics.setFont(font16)
	love.graphics.print("Welcome to Ved's new playtesting mode!\n\nTo be clear...", 32, 96)
	love.graphics.setColor(192,192,192)
	love.graphics.setFont(font8)
	love.graphics.printf([[Some parts of this version may not be fully accurate reproductions of VVVVVV's mechanics - things may feel a little different than you are used to. I know about that.


Some features are missing, some levels might not work.


As you probably know, Ved is an editor for VVVVVV. What you are about to play is a reproduction of VVVVVV's gameplay. If you haven't already, you can get VVVVVV at https://thelettervsixtim.es/. You can find the free Make and Play edition under the EDITOR menu button!



That said, have fun! Press ENTER to continue, you should only see this screen once.]], 32, 160, love.graphics.getWidth()-64, "left")
	love.graphics.setColor(255,255,255)
end
