--[[

DavVis states:
0	Main game
1	Game has crashed
2	"To be clear" page

]]

allocate_states("davvis", 3)

playbtn = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/play.png")

vis_crashmsgs = {
	["1"] = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/crashvsim1.png"),
	["1b"] = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/crashvsim1b.png"),
	["2"] = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/crashvsim2.png"),
	["2b"] = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/crashvsim2b.png"),
}

vis_crashbtn1 = {219, 227, 105, 23}
vis_crashbtn2 = {330, 227, 75, 23}

needle = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/needle.png")

rushed_conveyortiles_img = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/rushed_conveyortiles.png")
rushed_conveyortiles = {[-1] = {}, [1] = {}}
for tsy = 0, 1 do
	for tsx = 0, 3 do
		local ix = tsx+1
		if tsy == 1 then
			ix = 5-ix
		end
		rushed_conveyortiles[tsy*2-1][ix] = love.graphics.newQuad(tsx*8, tsy*8, 8, 8, 32, 16)
	end
end
rushed_disappeartiles_img = love.graphics.newImage(plugins["vis"].info.internal_pluginpath .. "/rushed_disappeartiles.png")
rushed_disappeartiles = {}
for tsx  = 0, 3 do
	rushed_disappeartiles[tsx+1] = love.graphics.newQuad(tsx*8, 0, 8, 8, 32, 8)
end

viss_spring = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/spring.ogg", "static")

viss_jump = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/jump.ogg", "static") -- 0
viss_jump2 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/jump2.ogg", "static") -- 1
viss_hurt = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/hurt.ogg", "static") -- 2
viss_souleyeminijingle = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/souleyeminijingle.ogg", "static") -- 3
viss_coin = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/coin.ogg", "static") -- 4
viss_save = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/save.ogg", "static") -- 5
viss_crumble = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crumble.ogg", "static") -- 6
viss_vanish = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/vanish.ogg", "static") -- 7
viss_blip = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/blip.ogg", "static") -- 8
viss_preteleport = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/preteleport.ogg", "static") -- 9
viss_teleport = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/teleport.ogg", "static") -- 10
viss_crew1 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crew1.ogg", "static") -- 11
viss_crew2 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crew2.ogg", "static") -- 12
viss_crew3 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crew3.ogg", "static") -- 13
viss_crew4 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crew4.ogg", "static") -- 14
viss_crew5 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crew5.ogg", "static") -- 15
viss_crew6 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crew6.ogg", "static") -- 16
viss_terminal = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/terminal.ogg", "static") -- 17
viss_gamesaved = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/gamesaved.ogg", "static") -- 18
viss_crashing = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crashing.ogg", "static") -- 19
viss_blip2 = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/blip2.ogg", "static") -- 20
viss_countdown = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/countdown.ogg", "static") -- 21
viss_go = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/go.ogg", "static") -- 22
viss_crash = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crash.ogg", "static") -- 23
viss_combine = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/combine.ogg", "static") -- 24
viss_newrecord = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/newrecord.ogg", "static") -- 25
viss_trophy = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/trophy.ogg", "static") -- 26
viss_rescue = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/rescue.ogg", "static") -- 27

vis_effectnumbers = {
	[0] = viss_jump, [1] = viss_jump2, [2] = viss_hurt, [3] = viss_souleyeminijingle,
	[4] = viss_coin, [5] = viss_save, [6] = viss_crumble, [7] = viss_vanish,
	[8] = viss_blip, [9] = viss_preteleport, [10] = viss_teleport, [11] = viss_crew1,
	[12] = viss_crew2, [13] = viss_crew3, [14] = viss_crew4, [15] = viss_crew5,
	[16] = viss_crew6, [17] = viss_terminal, [18] = viss_gamesaved, [19] = viss_crashing,
	[20] = viss_blip2, [21] = viss_countdown, [22] = viss_go, [23] = viss_crash,
	[24] = viss_combine, [25] = viss_newrecord, [26] = viss_trophy, [27] = viss_rescue,
}

viss_crashing_repeat = love.audio.newSource(plugins["vis"].info.internal_pluginpath .. "/sounds/crashing.ogg", "static")
viss_crashing_repeat:setLooping(true)

-- Music
vis_currentmusic = nil
vis_musicnumbers = {}

local status, err = pcall(function()
	local fh, everr = io.open(levelsfolder:sub(1, -8) .. dirsep .. "vvvvvvmusic.vvv", "rb")

	if fh == nil then
		cons("Couldn't open vvvvvvmusic because " .. anythingbutnil(everr))
		return
	end

	local ficontents = fh:read("*a")

	fh:close()

	local startAt, endAt, musStartAt, musEndAt, oldStartAt = 0
	local currentMus = 0

	while true do
		oldStartAt = startAt
		startAt = ficontents:find("OggS", oldStartAt + 1)
		if startAt == nil then
			startAt = 0
		end
		endAt = ficontents:find("OggS", startAt + 1)
		if endAt ~= nil then
			endAt = endAt - 1
		end
		if oldStartAt >= startAt then
			break
		end
		if endAt == nil then
			endAt = ficontents:len()
		end
		local sB = ficontents:sub(startAt+5, startAt+5):byte()
		if sB == 2 then
			musStartAt = startAt
		elseif sB == 4 then
			musEndAt = endAt
			cons("Found entire Ogg between " .. musStartAt .. " " .. musEndAt)
			cons("Number: " .. currentMus)
			vis_musicnumbers[currentMus] = love.audio.newSource(
				love.filesystem.newFileData(ficontents:sub(musStartAt, musEndAt), "song" .. currentMus .. ".ogg", "file")
			)
			if currentMus ~= 0 and currentMus ~= 7 then
				-- Only loop the songs which are supposed to loop
				vis_musicnumbers[currentMus]:setLooping(true)
			end
			currentMus = currentMus + 1
		end
	end
end, dt)

if not status then
	cons("Could not load vvvvvvmusic because " .. anythingbutnil(err))
end

vis_labbgcolors =
{
	{ {16, 121, 121}, {0, 15, 15} },
	{ {121, 16, 16}, {15, 0, 0} },
	{ {121, 16, 121}, {15, 0, 15} },
	{ {16, 16, 121}, {0, 0, 15} },
	{ {121, 121, 16}, {15, 15, 0} },
	{ {16, 121, 16}, {0, 15, 0} },
}

vis_timer = 0
vis_debug_frame = false
vis_debug_frame_next = false

vis_return_to_6 = false

ved_require("vis/entityclass/Player")

ved_require("vis/entityclass/Checkpoint")
ved_require("vis/entityclass/Conveyor")
ved_require("vis/entityclass/DisappearingPlat")
ved_require("vis/entityclass/Enemy")
ved_require("vis/entityclass/Gravityline")
ved_require("vis/entityclass/MovingPlat")
ved_require("vis/entityclass/Roomtext")
ved_require("vis/entityclass/Scriptbox")
ved_require("vis/entityclass/Terminal")
ved_require("vis/entityclass/Trinket")
ved_require("vis/entityclass/Warpline")
ved_require("vis/entityclass/Warptoken")

ved_require("vis/Scripting")
