local dt = ...

local status, err = pcall(function(dt)
	if in_astate("davvis", 0) then
		if vis_debug_frame and not vis_debug_frame_next then
			return
		end
		if vis_debug_frame_next then
			vis_debug_frame_next = false
		end

		vis_timer = (vis_timer + dt) % 2

		if vis_flashtimer > 0 then
			vis_flashtimer = math.max(vis_flashtimer - 30*dt, 0)
		end
		if vis_shaketimer > 0 then
			vis_shaketimer = math.max(vis_shaketimer - 30*dt, 0)
		end

		--[[
		local status, err = pcall(vis_scripting.update, vis_scripting, dt)

		if not status then
			vis_crash(err)
		end
		]]
		vis_scripting:update(dt)

		if vis_cutscenebars_dir and vis_cutscenebars < 320 then
			vis_cutscenebars = math.min(vis_cutscenebars + 960*dt, 320)
		elseif not vis_cutscenebars_dir and vis_cutscenebars > 0 then
			vis_cutscenebars = math.max(vis_cutscenebars - 960*dt, 0)
		end

		if not vis_scripting:blocking() then
			if love.keyboard.isDown("left") or love.keyboard.isDown("a") then
				vis_player:left(dt)
			elseif love.keyboard.isDown("right") or love.keyboard.isDown("d") then
				vis_player:right(dt)
			else
				vis_player:still(dt)
			end
		end

		vis_player:update(dt)

		-- A particular kind of unsolid entity (warp line) will set vis_player.roomwarp_imminent
		vis_player.roomwarp_imminent = 0

		for k,v in pairs(vis_solid_entities) do
			v:update(dt)
		end
		for k,v in pairs(vis_unsolid_entities) do
			v:update(dt)
		end

		if levelmetadata[(roomy)*20 + (roomx+1)].warpdir == 3 then
			warpbganimation = (warpbganimation + 2) % 64
		elseif levelmetadata[(roomy)*20 + (roomx+1)].warpdir ~= 0 then
			warpbganimation = (warpbganimation + 3) % 32
		end
	elseif in_astate("davvis", 1) then
		if vis_crash_movingwindow then
			vis_crash_x = vis_crash_movedfromwx + (love.mouse.getX()-vis_crash_movedfrommx)
			vis_crash_y = vis_crash_movedfromwy + (love.mouse.getY()-vis_crash_movedfrommy)
		end
	end
end, dt)

if not status then
	vis_crash(err)
end

--love.window.setPosition(-200,5)
