vCheckpoint =
{
	x = 0,
	y = 0,
	p1 = 0,
	active = false,
}

function vCheckpoint:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function vCheckpoint:draw(xoff, yoff)
	if not self.active then
		love.graphics.setColor(128, 128, 128)
	end
	drawentity(20+self.p1, xoff+screenoffset+self.x*2, yoff+self.y*2)
	love.graphics.setColor(255, 255, 255)
end

function vCheckpoint:update(dt)
	if vis_player:touching(self.x, self.y, 16, 16) and not self.active then
		-- First deactivate all checkpoints.
		for k,v in pairs(vis_unsolid_entities) do
			if getmetatable(v) == vCheckpoint then
				v.active = false
			end
		end
		vis_player:setcheckpoint(self.x+2, self.y-(self.p1 == 1 and 8 or 0), self.p1)
		self.active = true
		viss_save:stop()
		viss_save:play()
	end
end
