vConveyor =
{
	x = 0,
	y = 0,
	w = 32,
	h = 8,
	p1 = 0,
	destroyed = false,
	currentdir = 0, -- either -1 or 1 for left or right

	attached_ents = {},
}

function vConveyor:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	o.currentdir = (o.p1%2)*2-1
	o.w = o.p1 >= 7 and 64 or 32

	return o
end

function vConveyor:draw(xoff, yoff)
	if self.destroyed then
		return
	end

	love.graphics.setColor(
		tilesetblocks[levelmetadata[(roomy)*20 + (roomx+1)].tileset].colors[levelmetadata[(roomy)*20 + (roomx+1)].tilecol].entcolor
	)
	for t = 0, self.w/8-1 do
		love.graphics.draw(rushed_conveyortiles_img, vis_animate(rushed_conveyortiles[self.currentdir], 0.125), xoff+screenoffset+self.x*2 + 16*t, yoff+self.y*2, 0, 2)
	end
end

function vConveyor:update(dt)
	if self.destroyed then
		return
	end

	-- MOVE: 0 1 2 3 - onder boven links rechts (richting)

	local movement = 120*dt*self.currentdir

	for k,v in pairs(self.attached_ents) do
		if v.attached_to == self then
			v:correctcollision(v.x+movement, v.y, dt)
		end
	end
end

function vConveyor:destroy()
	self.destroyed = true
end

-- Todo: inheritance
function vConveyor:touching(x, y, w, h)
	if self.x >= x+w or self.x+self.w <= x then
		return false
	end
	if self.y >= y+h or self.y+self.h <= y then
		return false
	end
	return true
end

function vConveyor:hit(side, hitter, dt)
	-- Health warning: moving platforms in particular were rushed.

	-- SIDE: 1 2 3 4 - onder boven rechts links (van het platform)
	if side == nil then
		return false
	end

	if side == 1 or side == 2 then
		local is_attached = false
		for k,v in pairs(self.attached_ents) do
			if v == hitter then
				is_attached = true
			end
		end
		if not is_attached then
			table.insert(self.attached_ents, hitter)
		end
		return true
	end
	return false
end
