vDisappearingPlat =
{
	x = 0,
	y = 0,
	w = 32,
	h = 8,
	destroyed = false,

	destroying = false,
	destroytimer = 0.45,
}

function vDisappearingPlat:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function vDisappearingPlat:draw(xoff, yoff)
	if self.destroyed then
		return
	end

	love.graphics.setColor(
		tilesetblocks[levelmetadata[(roomy)*20 + (roomx+1)].tileset].colors[levelmetadata[(roomy)*20 + (roomx+1)].tilecol].entcolor
	)

	local ti = 5-math.ceil(self.destroytimer/0.1125)
	if ti >= 1 and ti <= 4 then
			for t = 0, self.w/8-1 do
				love.graphics.draw(rushed_disappeartiles_img, rushed_disappeartiles[ti], xoff+screenoffset+self.x*2 + 16*t, yoff+self.y*2, 0, 2)
			end
	end
	
	--[[
	love.graphics.draw(platformimg, platformpart[1], xoff+screenoffset+self.x*2, yoff+self.y*2, 0, 2)
	love.graphics.draw(platformimg, platformpart[2], xoff+screenoffset+self.x*2 + 16, yoff+self.y*2, 0, 2)
	love.graphics.draw(platformimg, platformpart[2], xoff+screenoffset+self.x*2 + 32, yoff+self.y*2, 0, 2)
	love.graphics.draw(platformimg, platformpart[3], xoff+screenoffset+self.x*2 + 48, yoff+self.y*2, 0, 2)
	]]
	-- This is a disappearing platform.
	--love.graphics.setColor(255,255,255,255)
	--love.graphics.setFont(font16)
	--love.graphics.print("////", xoff+screenoffset+self.x*2, yoff+self.y*2 + 3)
	--love.graphics.print(self.lastmode, xoff+screenoffset+self.x*2, yoff+self.y*2 + 3)

	-- Temp
	--love.graphics.print(math.floor(self.destroytimer * 10000), xoff+screenoffset+self.x*2, yoff+self.y*2 + 3)

	--love.graphics.setFont(font8)

	love.graphics.setColor(255, 255, 255)
end

function vDisappearingPlat:update(dt)
	if self.destroyed then
		return
	end

	if self.destroying then
		self.destroytimer = self.destroytimer - dt

		if self.destroytimer <= 0 then
			self.destroyed = true
			return
		end
	end
end

-- Todo: inheritance
function vDisappearingPlat:touching(x, y, w, h)
	if self.x >= x+w or self.x+self.w <= x then
		return false
	end
	if self.y >= y+h or self.y+self.h <= y then
		return false
	end
	return true
end

function vDisappearingPlat:hit(side)
	if not self.destroying and (side == 1 or side == 2) then
		self.destroying = true

		viss_vanish:stop()
		viss_vanish:play()
	end
end

function vDisappearingPlat:restore()
	self.destroying = false
	self.destroyed = false
	self.destroytimer = 0.45
end
