vGravityline =
{
	x = 0,
	y = 0,
	p1 = 0,
	p2 = 0,
	p3 = 0,
	playertouching = false,
	destroyed = false,
}

function vGravityline:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function vGravityline:draw(xoff, yoff)
	if self.destroyed then
		return
	end

	if self.playertouching then
		love.graphics.setColor(128, 128, 128)
	end
	if self.p1 == 0 then
		-- Horizontal
		love.graphics.line(
			screenoffset+xoff+self.p2*16 + 1,
			yoff+self.y*2 + 8,
			screenoffset+xoff+self.p2*16 + self.p3*2 - 1,
			yoff+self.y*2 + 8
		)
	else
		-- Vertical
		love.graphics.line(
			screenoffset+xoff+self.x*2 + 8,
			yoff+self.p2*16 + 1,
			screenoffset+xoff+self.x*2 + 8,
			yoff+self.p2*16 + self.p3*2 - 1
		)
	end
	love.graphics.setColor(255, 255, 255)
end

function vGravityline:update(dt)
	if self.destroyed then
		return
	end

	if self.p1 == 0 and vis_player:touching(self.p2*8, self.y+3, self.p3, 2) -- Horizontal
	or self.p1 == 1 and vis_player:touching(self.x+3, self.p2*8, 2, self.p3) -- Vertical
	then
		if not self.playertouching then
			self.playertouching = true
			viss_blip:stop()
			viss_blip:play()
			if self.p1 == 0 and vis_player:isgoingup() then
				-- The player is hitting this horizontal line with their head while jumping
				vis_player:headbump(224)
			else
				vis_player:forcejump(true)
			end
		end
	else
		self.playertouching = false
	end
end

function vGravityline:destroy()
	self.destroyed = true
end
