vPlayer =
{
	x = 0,
	y = 0,
	w = 12,
	h = 21,
	flipped = false,
	dir = 0,
	vx = 0,
	vup = 0,
	standing = false,
	standing_y = 0,
	moving = false,
	visible = true,
	frozen = false,
	mood = 0,
	checkpointrx = 0,
	checkpointry = 0,
	checkpointx = 0,
	checkpointy = 0,
	checkpointz = false,
	died = false,
	deathtimer = 0,
	invincible = false,
	roomwarp_imminent = 0,
	flippable = false,
	color = "cyan",
	defaultcolor = "cyan",
	is_main_player = false,
	rescuable = false,
	destroyed = false,
	ai = nil,
	ai2 = nil,
	tileoffset = 0,
	attached_to = nil,
	deaths = 0,
}

function vPlayer:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	o:setcheckpoint()

	return o
end

function vPlayer:draw(xoff, yoff)
	if self.destroyed then
		return
	end

	-- Only if debug, but that's obvious
	if self.is_main_player and false then
		love.graphics.print("X: " .. math.floor(self.x) .. " (" .. self.x .. ")\nY: " .. math.floor(self.y) .. " (" .. self.y .. ")\n\n" .. (self.standing and ">STANDING</ falling" or " standing />FALLING<") .. "\n\n" .. (self:xaligned() and "[X]" or "[ ]") .. (self:yaligned() and "[Y]" or "[ ]") .. " x/y align\n\nVX: " .. self.vx .. "\nVUP: " .. self.vup .. "\nRoom " .. roomx .. "," .. roomy .. "\nImmin. warp: " .. self.roomwarp_imminent .. "\nDir: " .. self.dir, 158, 42)
		love.graphics.setColor(192, 192, 192, 128)
		love.graphics.circle("fill", 146, 99, 8)
		love.graphics.setColor(255, 0, 0, 128)
		love.graphics.draw(needle, 146, 99, (self.vx/220)*math.pi, nil, nil, 8, 8)
	end
	if not self.visible then
		--love.graphics.setColor(255,0,0,128)
		--love.graphics.rectangle("fill", screenoffset+self.x*2, self.y*2, self.w*2, self.h*2)
		return
	end
	if self.died then
		love.graphics.setColor(192, 10, 10)
		local deathsprite = self.tileoffset + 3*(1-self.dir) + 144 + (self.flipped and 6 or 0)
		if self.deathtimer > 20 then -- Death timer is initially 30 upon death
			drawentity(deathsprite, xoff+screenoffset+self.x*2 - 12, yoff+self.y*2 - 4)
		else
			drawentity(vis_animate({deathsprite, 191}, 0.0625), xoff+screenoffset+self.x*2 - 12, yoff+self.y*2 - 4)
		end
		love.graphics.setColor(255, 255, 255)
		return
	end
--
	--love.graphics.setColor(255,0,0,128)
	--love.graphics.rectangle("fill", screenoffset+self.x*2, self.y*2, self.w*2, self.h*2)
--
	if self.color == "teleporter" then
		love.graphics.setColor(
			love.math.random(0, 255),
			love.math.random(0, 255),
			love.math.random(0, 255)
		)
	elseif self.color == "purple" then
		love.graphics.setColor(255, 135, 255)
	elseif self.color == "yellow" then
		love.graphics.setColor(255, 255, 135)
	elseif self.color == "red" then
		love.graphics.setColor(255, 61, 61)
	elseif self.color == "green" then
		love.graphics.setColor(144, 255, 144)
	elseif self.color == "blue" then
		love.graphics.setColor(75, 75, 230)
	else
		love.graphics.setColor(132, 181, 255)
	end
	local sprite_offset = self.tileoffset + 3*(1-self.dir) + 144*(vis_player:isdead() and 1 or self.mood) + (self.flipped and 6 or 0)
	if self.moving then
		-- Walking animation
		drawentity(vis_animate({0+sprite_offset, 1+sprite_offset}, 0.125), xoff+screenoffset+self.x*2 - 12, yoff+self.y*2 - 4)
	elseif not self.standing and self.vup <= 224 then
		drawentity(1+sprite_offset, xoff+screenoffset+self.x*2 - 12, yoff+self.y*2 - 4)
	else
		drawentity(sprite_offset, xoff+screenoffset+self.x*2 - 12, yoff+self.y*2 - 4)
	end
	love.graphics.setColor(255,255,255)
end

function vPlayer:update(dt)
	if self.destroyed then
		return
	end
	if self.ai == "faceleft" then
		self.dir = 0
		self.ai = nil
	elseif self.ai == "faceright" then
		self.dir = 1
		self.ai = nil
	elseif self.ai == "faceplayer" then
		self.dir = (vis_player.x > self.x) and 1 or 0
	elseif self.ai == "followposition" then
		if self.ai2 > self.x and self.x < self.ai2-48 then
			self:right(dt)
		elseif self.ai2 < self.x and self.x > self.ai2+48 then
			self:left(dt)
		else
			self:still(dt)
		end
	end
	-- Is this not the player, but just a rescuable crewmate?
	if self.rescuable and vis_player:touching(self.x, self.y, self.w, self.h) then
		vis_mark_collected(vis_crewmates_coll, self.checkpointx-2, self.checkpointy)
		vis_n_crewmates = vis_n_crewmates + 1
		self.destroyed = true
		viss_rescue:stop()
		viss_rescue:play()

		vis_player.frozen = true

		-- Script
		local remaining = vis_crewmates_total - vis_n_crewmates
		vis_scripting:load_manually(
			{
				"cutscene()",
				"untilbars()",
				"text(gray,0,85,3)",
				"        Congratulations!",
				"",
				"You have found a lost crewmate!",
				"position(centerx)",
				"backgroundtext",
				"speak_active",
				"text(gray,0,135,1)",
				remaining == 0 and " All crewmates rescued! " or (" " .. remaining .. " remain" .. (remaining == 1 and "s " or " ")),
				"position(centerx)",
				"speak",
				"endtext",
				"endcutscene()",
				"vis_playerfreeze(0)",
				"vis_checkfinished",
			}
		)
	end
	-- Frozen?
	if self.frozen then
		return
	end
	-- If you just died you're not moving, sorry, get well soon.
	if self.deathtimer > 0 then
		self.deathtimer = math.max(self.deathtimer - 30*dt, 0)
		return
	end
	if self.died then
		--self.x, self.y, self.flipped = self.checkpointx, self.checkpointy, self.checkpointz
		if self.checkpointrx ~= roomx or self.checkpointry ~= roomy then
			gotoroom(self.checkpointrx, self.checkpointry)
			vis_init_room()
		else
			-- Same room, so reinstate all the disappearing platforms!
			for k,v in pairs(vis_solid_entities) do
				if getmetatable(v) == vDisappearingPlat then
					v:restore()
				end
			end
		end
		self:teleport(self.checkpointx, self.checkpointy)
		self.flipped = self.checkpointz
		self.died = false
	end


	local new_x, new_y = self.x, self.y

	-- Moving sideways?
	if self.vx ~= 0 then
		new_x = self.x + self.vx*dt
	end

	-- Jumping?
	if self.vup > 0 then
		if self.flipped then
			new_y = self.y + self.vup*dt
		else
			new_y = self.y - self.vup*dt
		end
		self.vup = math.max(self.vup - 900*dt, 0)
	end

	-- Falling?
	if self.flipped then
		new_y = new_y - 224*dt
	else
		new_y = new_y + 224*dt
	end

	-- Debug thing, move to new location with mouse
	if self.is_main_player and false then
		if love.mouse.isDown("l") then
			new_x, new_y = (love.mouse.getX()-screenoffset)/2, love.mouse.getY()/2
		end
	end

	-- Reset the current attachment, let them renew it if we're still hitting
	self.attached_to = nil

	-- Handle any collision with walls: basically let the move be corrected and applied.
	self:correctcollision(new_x, new_y, dt)

	-- Have we fallen off the edge?
	if self.standing and self.y ~= self.standing_y then
		self.standing = false
	end

	-- After all the corrections, are we feeling pain somewhere?
	if (self:isinsidespike()) then
		self:hurt()
	end

	-- Maybe we're going offscreen?
	if self.is_main_player then
		if self.x < -self.w/2 then
			if vis_will_not_warp(1) then
				if roomx+1 <= 1 then
					roomx = metadata.mapwidth-1
				else
					roomx = roomx - 1
				end
				gotoroom_finish()
				vis_init_room()
			end
			self:teleportrelative(320,0)
		elseif self.x > 320-(self.w/2) then
			if vis_will_not_warp(1) then
				if roomx+1 >= metadata.mapwidth then
					roomx = 0
				else
					roomx = roomx + 1
				end
				gotoroom_finish()
				vis_init_room()
			end
			self:teleportrelative(-320,0)
		end
		if self.y < -self.h/2 then
			if vis_will_not_warp(2) then
				if roomy+1 <= 1 then
					roomy = metadata.mapheight-1
				else
					roomy = roomy - 1
				end
				gotoroom_finish()
				vis_init_room()
			end
			self:teleportrelative(0,240)
		elseif self.y > 240-(self.h/2) then
			if vis_will_not_warp(2) then
				if roomy+1 >= metadata.mapheight then
					roomy = 0
				else
					roomy = roomy + 1
				end
				gotoroom_finish()
				vis_init_room()
			end
			self:teleportrelative(0,-240)
		end
	end
end

function vPlayer:left(dt)
	if self.deathtimer > 0 then
		return
	end

	if self.vx > 0 then
		self.vx = 0
	elseif self.vx > -192 then
		self.vx = math.max(self.vx - 768*dt, -192)
	end
	if self.dir == 1 then
		self.dir = 0
	end
	if not self.moving then
		self.moving = true
	end
end

function vPlayer:right(dt)
	if self.deathtimer > 0 then
		return
	end

	if self.vx < 0 then
		self.vx = 0
	elseif self.vx < 192 then
		self.vx = math.min(self.vx + 768*dt, 192)
	end
	if self.dir == 0 then
		self.dir = 1
	end
	if not self.moving then
		self.moving = true
	end
end

function vPlayer:still(dt)
	if self.deathtimer > 0 then
		return
	end

	if self.vx < 0 then
		self.vx = math.min(self.vx + 768*dt, 0)
	elseif self.vx > 0 then
		self.vx = math.max(self.vx - 768*dt, 0)
	end
	if self.moving then
		self.moving = false
	end
end

function vPlayer:jump(silent)
	if not self.standing then -- or #vvvvvv_textboxes > 0  is not a good idea
		return
	end

	self:forcejump(silent)
end

function vPlayer:forcejump(silent)
	if self.deathtimer > 0 then
		return
	end

	self.standing = false
	if self.flippable then
		self.flipped = not self.flipped
		if self.flipped then
			if not silent then
				viss_jump:stop()
				viss_jump:play()
			end
		else
			if not silent then
				viss_jump2:stop()
				viss_jump2:play()
			end
		end
	else
		self.vup = 512
		if not silent then
			viss_spring:stop()
			viss_spring:play()
		end
	end
end

function vPlayer:tofloor()
	if not self.standing or not self.flipped then
		return
	end

	self:forcetofloor()
end

function vPlayer:forcetofloor(silent)
	if self.deathtimer > 0 then
		return
	end

	self.standing = false
	self.flipped = false
	if not silent then
		viss_jump2:stop()
		viss_jump2:play()
	end
end

function vPlayer:setflipped(status)
	self.flipped = status
end

function vPlayer:verticaltouch(goingup)
	-- To be called when the player hits either a floor or a ceiling.
	-- Depending on whether the player is falling down or jumping up, this will count as standing or a headbump.
	-- "goingup" means that the player is moving vertically to the top of the screen, not that the player is jumping.
	local ceiling = goingup

	if self.flipped then
		ceiling = not ceiling
	end

	if ceiling then
		self:headbump(0)
	elseif not self.standing then
		self.standing = true
		self.standing_y = self.y
	end
end

function vPlayer:headbump(extrapush)
	if extrapush == nil then
		extrapush = 0
	end
	self.vup = 224 - extrapush
end

function vPlayer:isgoingup()
	return self.vup > 224
end

function vPlayer:correctcollision(new_x, new_y, dt)
	if new_x == self.x and new_y == self.y then
		return
	end
	if self.deathtimer > 0 then
		return
	end

	-- Dynamically calculate the necessary number of "new player x/ys in between", so clipping through things is impossible.
	-- Ok, dus dat doe je als volgt:
	-- het aantal stappen dat je moet nemen is max(ceil(dx/8), ceil(dy/8))
	-- als je zeg maar dx=4 (0.5 tile) hebt en dy=4 (0.5 tile), dan is er niks aan de hand, max(1,1) is 1 stap: direct van oud naar nieuw
	-- als je dy=24 (3 tiles) hebt, dan heb je dus 3 stappen: dat is 2 meer dan 1, dus twee TUSSENstappen. Van oud naar 1, van 1 naar 2, van 2 naar nieuw.
	-- Die stappen zijn HEEL simpel: gewoon, is in 1 de speler in een muur? Nee, ok dan gaan we naar 2, nu wel? Oh, nu wel, handle it, en 1 heeft onze oude x en y nu.
	-- Verdere stappen worden dan niet gezet, je handelt alleen die collision-stap af en dan is dat het resultaat.

	-- TODO: Misschien bij meerdere stappen toch self.x en self.y veranderen (prev_x en prev_y had ik), want muren enzo

	-- 1 step means: no intermediate steps needed, go directly from old to new.
	-- 2 steps means: 1 intermediate step needed, go from old to 1 to new. etc
	local diff_x, diff_y = new_x-self.x, new_y-self.y
	local necessary_steps = math.max(
		math.ceil(math.abs(diff_x)/8),
		math.ceil(math.abs(diff_y)/8)
	)
	local is_inside_wall = false
	for step = 1, necessary_steps do
		local step_newx = self.x+((diff_x/necessary_steps)*step)
		local step_newy = self.y+((diff_y/necessary_steps)*step)
		if self:isinsidewall(step_newx, step_newy) then
			is_inside_wall = true
			new_x, new_y = step_newx, step_newy
			break
		end
	end

	if is_inside_wall then
		-- The player is in a wall. Fix it!
		local ts = usedtilesets[levelmetadata[(roomy)*20 + (roomx+1)].tileset]
		local x_corr, y_corr = new_x, new_y

		if new_y < self.y then -- going up
			-- Check if we're even hitting a tile upwards.
			local n_coll, corr_ty = 0, -9999
			local first_tile_coll, last_tile_coll = false, false
			local first = true
			for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles(new_x, new_y, 1) do
				if tsolid then
					if first then
						first_tile_coll = true
					end
					n_coll = n_coll + 1
					last_tile_coll = true

					if ty*8+th > corr_ty then
						corr_ty = ty*8+th
					end
				else
					last_tile_coll = false
				end
				first = false
			end
			-- TODO: Make sure there's not a var in between anymore if not needed anymore
			if corr_ty ~= -9999 then
				y_corr = corr_ty
			end

			-- Don't correct beyond the old good position!
			if y_corr > self.y then
				y_corr = self.y
			end

			-- It's not actually a silly left/right collision, correct?
			if n_coll == 1 and (first_tile_coll or last_tile_coll) then
				local n_sidecoll = 0
				for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles(new_x, new_y, first_tile_coll and 3 or 4) do
					if tsolid then
						n_sidecoll = n_sidecoll + 1
					end
				end
				-- More than one tile collision on the side means we are on the side of a wall.
				if n_sidecoll > 1 then
					-- Disqualified, nothing actually happened
					n_coll = 0
				end
			end
			-- So is there collision upwards?
			if n_coll > 0 and not self:isinsidewall(new_x, y_corr) then
				-- Seems solved, apply our new Y
				self.x = new_x
				self.y = y_corr
				self:verticaltouch(true)
				--cons("GOING UP, CORRECTING " .. new_y .. " TO " .. y_corr)
				return
			end
		elseif new_y > self.y then -- going down
			-- Check if we're even hitting a tile downwards.
			local n_coll, corr_ty = 0, 9999
			local first_tile_coll, last_tile_coll = false, false
			local first = true
			for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles(new_x, new_y, 2) do
				if tsolid then
					if first then
						first_tile_coll = true
					end
					n_coll = n_coll + 1
					last_tile_coll = true

					if ty*8-self.h < corr_ty then
						corr_ty = ty*8-self.h
					end
				else
					last_tile_coll = false
				end
				first = false
			end
			if corr_ty ~= 9999 then
				y_corr = corr_ty
			end

			-- Don't correct beyond the old good position!
			if y_corr < self.y then
				y_corr = self.y
			end

			-- It's not actually a silly left/right collision, correct?
			if n_coll == 1 and (first_tile_coll or last_tile_coll) then
				local n_sidecoll = 0
				for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles(new_x, new_y, first_tile_coll and 3 or 4) do
					if tsolid then
						n_sidecoll = n_sidecoll + 1
					end
				end
				-- More than one tile collision on the side means we are on the side of a wall.
				if n_sidecoll > 1 then
					-- Disqualified, nothing actually happened
					n_coll = 0
				end
			end
			-- So is there collision downwards?
			if n_coll > 0 and not self:isinsidewall(new_x, y_corr) then
				-- Seems solved, apply our new Y
				self.x = new_x
				self.y = y_corr
				self:verticaltouch(false)
				--cons("GOING DOWN, CORRECTING " .. new_y .. " TO " .. y_corr)
				return
			end
		end
		if new_x < self.x then -- going left
			-- Check if we're even hitting a tile to the left.
			local n_coll, corr_tx = 0, -9999
			for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles(new_x, new_y, 3) do
				if tsolid then
					n_coll = n_coll + 1

					if tx*8+tw > corr_tx then
						corr_tx = tx*8+tw
					end
				end
			end
			if corr_tx ~= -9999 then
				x_corr = corr_tx
			end

			-- Don't correct beyond the old good position!
			if x_corr > self.x then
				x_corr = self.x
			end

			if n_coll > 0 and not self:isinsidewall(x_corr, new_y) then
				-- Solved, apply new X
				self.x = x_corr
				self.y = new_y
				--cons("GOING LEFT, CORRECTING " .. new_x .. " TO " .. x_corr)
				return
			end
		elseif new_x > self.x then -- going right
			-- Check if we're even hitting a tile to the right.
			local n_coll, corr_tx = 0, 9999
			for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles(new_x, new_y, 4) do
				if tsolid then
					n_coll = n_coll + 1

					if tx*8-self.w < corr_tx then
						corr_tx = tx*8-self.w
					end
				end
			end
			if corr_tx ~= 9999 then
				x_corr = corr_tx
			end

			-- Don't correct beyond the old good position!
			if x_corr < self.x then
				x_corr = self.x
			end

			if n_coll > 0 and not self:isinsidewall(x_corr, new_y) then
				-- Solved, apply new X
				self.x = x_corr
				self.y = new_y
				--cons("GOING RIGHT, CORRECTING " .. new_x .. " TO " .. x_corr)
				return
			end
		end

		-- Apparently changing either y or x alone didn't solve this collision, but both should.
		-- If that doesn't either, just give up, we're stuck in a wall.
		if not self:isinsidewall(x_corr, y_corr) then
			self.x = x_corr
			self.y = y_corr
			--cons("APPARENTLY EITHER X/Y DOESN'T WORK SO CORRECTING " .. new_x .. " TO " .. x_corr .. " AND " .. new_y .. " TO " .. y_corr)
			self:verticaltouch(new_y < self.y)
		else
			--cons("PRETTY DAMN STUCK")
			-- Just slide the player up a bit
			self.y = self.y-64*dt
		end
		return
	end

	-- Apparently there's no collision! Just apply the new position.
	self.x = new_x
	self.y = new_y
end

function vPlayer:alltouchingtiles(custom_x, custom_y, mode)
	-- Iterator, returning each x, y and tile number of tiles touched by the player
	--[[ mode is one of following things:
		nil/default: return all tiles
		1: return only tiles on top edge
		2: return only tiles on bottom edge
		3: return only tiles on left edge
		4: return only tiles on right edge
	]]
	if custom_x == nil then custom_x = self.x end
	if custom_y == nil then custom_y = self.y end

	-- start and end
	local touching_xs, touching_xn, touching_ys, touching_yn

	-- Where is the floored block the player is, at the top left?
	local px, py = math.floor(custom_x/8), math.floor(custom_y/8)

	-- So which tiles are we touching?
	touching_xs, touching_xn = px, (self:xaligned(custom_x) and 2 or 3)
	touching_ys, touching_yn = py, (self:yaligned(custom_y) and 3 or 4)

	local curr_x, curr_y = 0, 0

	-- Now handle the mode, if we only want the tiles on a certain side of the player.
	if mode == 1 then
		-- Only top
		touching_yn = 1
	elseif mode == 2 then
		-- Only bottom
		touching_ys = py + touching_yn - 1
		touching_yn = 1
	elseif mode == 3 then
		-- Only left
		touching_xn = 1
	elseif mode == 4 then
		-- Only right
		touching_xs = px + touching_xn - 1
		touching_xn = 1
	end

	-- We also need to check solid entities.
	local touching_ents, current_ent = {}, 0
	for k,v in pairs(vis_solid_entities) do
		if not v.destroyed and v:touching(custom_x, custom_y, self.w, self.h) then
			-- If we're in one of the modes, we only want entities that we'd not frown at to correct for
			-- If you're checking going left, you don't want to jump 24 pixels to the right just because
			-- gravity also pulled you into a platform below you. That is handled by the checks for going down.
			if mode == 1 and v.y+v.h > self.y then
			elseif mode == 2 and v.y-self.h < self.y then
			elseif mode == 3 and v.x+v.w > self.x then
			elseif mode == 4 and v.x-self.w < self.x then
			else
				table.insert(touching_ents, v)

				-- Also notify the entity, maybe it wants to do something.
				local attach = v:hit(mode, self)

				-- Does the entity want us to stick to them?
				if attach then
					self.attached_to = v
				end
			end
		end
	end

	return function()
		-- These are the values we're going to return
		local ret_x, ret_y = touching_xs+curr_x, touching_ys+curr_y

		-- Unless we're actually done!
		if curr_y >= touching_yn then
			-- But we might still need to do solid entities.
			if current_ent >= #touching_ents then
				return nil
			end
			current_ent = current_ent + 1
			return touching_ents[current_ent].x/8,
			       touching_ents[current_ent].y/8,
			       true,
			       touching_ents[current_ent].w,
			       touching_ents[current_ent].h,
			       false
		end

		-- Also don't tell me we're going to check an offscreen tile.
		if ret_x < 0 then
			ret_x = 0
		elseif ret_x > 39 then
			ret_x = 39
		end
		if ret_y < 0 then
			ret_y = 0
		elseif ret_y > 29 then
			ret_y = 29
		end

		-- Before returning, first prepare the next ones.
		curr_x = curr_x + 1
		if curr_x >= touching_xn then
			curr_y = curr_y + 1
			curr_x = 0
		end

		local tilenum = ((ret_y)*40)+((ret_x)+1)
		local spike = (issolid(roomdata[roomy][roomx][tilenum], usedtilesets[levelmetadata[(roomy)*20 + (roomx+1)].tileset], false, false)
		            ~= issolid(roomdata[roomy][roomx][tilenum], usedtilesets[levelmetadata[(roomy)*20 + (roomx+1)].tileset], true, false))

		return ret_x, ret_y, issolid(roomdata[roomy][roomx][tilenum], usedtilesets[levelmetadata[(roomy)*20 + (roomx+1)].tileset], self.invincible, false), 8, 8, spike
	end
end

function vPlayer:isinsidewall(custom_x, custom_y)
	-- Just returns true or false
	if custom_x == nil then custom_x = self.x end
	if custom_y == nil then custom_y = self.y end

	for tx, ty, tsolid in self:alltouchingtiles(custom_x, custom_y) do
		--cons("Hey, I'm now checking whether the player is in a wall at " .. tx .. "," .. ty)
		if tsolid then
			return true
		end
	end
	return false
end

function vPlayer:isinsidespike()
	if self.invincible then
		return false
	end

	for tx, ty, tsolid, tw, th, tspike in self:alltouchingtiles() do
		if tspike then
			return true
		end
	end
	return false
end

function vPlayer:xaligned(x)
	if x == nil then x = self.x end

	return x%8 <= 4
end

function vPlayer:yaligned(y)
	if y == nil then y = self.y end

	return y%8 <= 3
end

function vPlayer:touching(x, y, w, h)
	if self.x >= x+w or self.x+self.w <= x then
		return false
	end
	if self.y >= y+h or self.y+self.h <= y then
		return false
	end
	return true
end

function vPlayer:hurt()
	if self.deathtimer > 0 or self.died then
		-- Not returning here would be pretty amusing with enemies
		return
	end

	viss_hurt:stop()
	viss_hurt:play()
	self.died = true
	self.deathtimer = 30
	self.vup = 0
	self.vx = 0
	self.color = self.defaultcolor

	self.deaths = self.deaths + 1
end

function vPlayer:teleport(x,y)
	self.x = x
	self.y = y
end

function vPlayer:teleportrelative(x,y)
	self.x = self.x + x
	self.y = self.y + y
end

function vPlayer:setcheckpoint(x,y,z)
	if x == nil then x = self.x end
	if y == nil then y = self.y end
	if z == nil then z = self.flipped end
	if type(z) == "number" then z = (z == 0) end

	self.checkpointrx, self.checkpointry = roomx, roomy
	self.checkpointx, self.checkpointy, self.checkpointz = x, y, z
end

function vPlayer:hide()
	self.visible = false
end

function vPlayer:show()
	self.visible = true
end

function vPlayer:isdead()
	return self.deathtimer > 0 or self.died
end
