vTerminal =
{
	x = 0,
	y = 0,
	script = nil,
	lit = false,
	finished = false,
	playertouching = false,
}

function vTerminal:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function vTerminal:draw(xoff, yoff)
	if not self.lit then
		love.graphics.setColor(128, 128, 128)
	end
	drawentity(17, xoff+screenoffset+self.x*2, yoff+self.y*2 + 16)
	love.graphics.setColor(255, 255, 255)

	if not self.finished and self.playertouching then
		vvvvvv_textbox({255,130,20}, 24, 0, {"Press ENTER to activate terminal"})
	end
end

function vTerminal:update(dt)
	if vis_player:touching(self.x, self.y, 16, 24) then
		if not self.lit then
			self.lit = true
			viss_terminal:stop()
			viss_terminal:play()
		end
		if not self.finished then
			if not self.playertouching then
				self.playertouching = true
			end
			if love.keyboard.isDown("return") and not vis_scripting:blocking() then
				vis_scripting:loadscript(self.script)
				self.finished = true
			end
		end
	elseif self.playertouching then
		self.playertouching = false
	end
end
