vWarptoken =
{
	x = 0,
	y = 0,
	dx = 0,
	dy = 0,
	destroyed = false,
}

function vWarptoken:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function vWarptoken:draw(xoff, yoff)
	if self.destroyed then
		return
	end

	drawentity(vis_animate({18, 19}, 0.25), xoff+screenoffset+self.x*2, yoff+self.y*2)
end

function vWarptoken:update(dt)
	if self.destroyed then
		return
	end

	if vis_player:touching(self.x, self.y, 16, 16) then
		local newroomx, newroomy = math.floor(self.dx / 40), math.floor(self.dy / 30)
		--if roomx ~= newroomx or roomy ~= newroomy then -- turns out VVVVVV always inits the room
		gotoroom(newroomx, newroomy)
		vis_init_room()
		--end
		vis_player:teleport((self.dx-newroomx*40)*8, (self.dy-newroomy*30)*8-8)
		vis_player:forcetofloor(true)
		vis_flashtimer = 5
		vis_shaketimer = 20
		viss_teleport:stop()
		viss_teleport:play()
	end
end

function vWarptoken:destroy()
	self.destroyed = true
end